## snapd 2.65.1

=== debian/changelog ===
snapd (2.65.1-1) unstable; urgency=medium

  [ Ernest Lotter ]
  * New upstream release, LP: #2077473
    - Support building snapd using base Core22 (Snapcraft 8.x)
    - FIPS: support building FIPS complaint snapd variant that switches
      to FIPS mode when the system boots with FIPS enabled
    - AppArmor: update to latest 4.0.2 release
    - AppArmor: enable using ABI 4.0 from host parser
    - AppArmor: fix parser lookup
    - AppArmor: support AppArmor snippet priorities
    - AppArmor: allow reading cgroup memory.max file
    - AppArmor: allow using snap-exec coming from the snapd snap when
      starting a confined process with jailmode
    - AppArmor prompting (experimental): add checks for prompting
      support, include prompting status in system key, and restart snapd
      if prompting flag changes
    - AppArmor prompting (experimental): include prompt prefix in
      AppArmor rules if prompting is supported and enabled
    - AppArmor prompting (experimental): add common types, constraints,
      and mappings from AppArmor permissions to abstract permissions
    - AppArmor prompting (experimental): add path pattern parsing and
      matching
    - AppArmor prompting (experimental): add path pattern precedence
      based on specificity
    - AppArmor prompting (experimental): add packages to manage
      outstanding request prompts and rules
    - AppArmor prompting (experimental): add prompting API and notice
      types, which require snap-interfaces-requests-control interface
    - AppArmor prompting (experimental): feature flag can only be
      enabled if prompting is supported, handler service connected, and
      the service can be started
    - Registry views (experimental): rename from aspects to registries
    - Registry views (experimental): support reading registry views and
      setting/unsetting registry data using snapctl
    - Registry views (experimental): fetch and refresh registry
      assertions as needed
    - Registry views (experimental): restrict view paths from using a
      number as first character and view names to storage path style
      patterns
    - Snap components: support installing snaps and components from
      files at the same time (no REST API/CLI)
    - Snap components: support downloading components related assertions
      from the store
    - Snap components: support installing components from the store
    - Snap components: support removing components individually and
      during snap removal
    - Snap components: support kernel modules as components
    - Snap components: support for component install, pre-refresh and
      post-refresh hooks
    - Snap components: initial support for building systems that contain
      components
    - Refresh app awareness (experimental): add data field for
      /v2/changes REST API to allow associating each task with affected
      snaps
    - Refresh app awareness (experimental): use the app name from
      .desktop file in notifications
    - Refresh app awareness (experimental): give snap-refresh-observe
      interface access to /v2/snaps/{name} endpoint
    - Improve snap-confine compatibility with nvidia drivers
    - Allow re-exec when SNAP_REEXEC is set for unlisted distros to
      simplify testing
    - Allow mixing revision and channel on snap install
    - Generate GNU build ID for Go binaries
    - Add missing etelpmoc.sh for shell completion
    - Do not attempt to run snapd on classic when re-exec is disabled
    - Packaging/build maintenance for Debian sid, Fedora, Arch, openSuse
    - Add snap debug API command to enable running raw queries
    - Enable snap-confine snap mount directory detection
    - Replace global seccomp filter with deny rules in standard seccomp
      template
    - Remove support for Ubuntu Core Launcher (superseded by snap-
      confine)
    - Support creating pending serial bound users after serial assertion
      becomes available
    - Support disabling cloud-init using kernel command-line
    - In hybrid systems, apps can refresh without waiting for restarts
      required by essential snaps
    - Ship snap-debug-info.sh script used for system diagnostics
    - Improve error messages when attempting to run non-existent snap
    - Switch to -u UID:GID for strace-static
    - Support enabling snapd logging with snap set system
      debug.snapd.{log,log-level}
    - Add options system.coredump.enable and system.coredump.maxuse to
      support using systemd-coredump on Ubuntu Core
    - Provide documentation URL for 'snap interface '
    - Fix snapd riscv64 build
    - Fix restarting activated services instead of their activator units
      (i.e. sockets, timers)
    - Fix potential unexpected auto-refresh of snap on managed schedule
    - Fix potential segfault by guarding against kernel command-line
      changes on classic system
    - Fix proxy entries in /etc/environment with missing newline that
      caused later manual entries to not be usable
    - Fix offline remodelling by ignoring prerequisites that will
      otherwise be downloaded from store
    - Fix devmode seccomp deny regression that caused spamming the log
      instead of actual denies
    - Fix snap lock leak during refresh
    - Fix not re-pinning validation sets that were already pinned when
      enforcing new validation sets
    - Fix handling of unexpected snapd runtime failure
    - Fix /v2/notices REST API skipping notices with duplicate
      timestamps
    - Fix comparing systemd versions that may contain pre-release
      suffixes
    - Fix udev potentially starting before snap-device-helper is made
      available
    - Fix race in snap seed metadata loading
    - Fix treating cloud-init exit status 2 as error
    - Fix to prevent sending refresh complete notification if snap snap-
      refresh-observe interface is connected
    - Fix to queue snapctl service commands if run from the default-
      configure hook to ensure they get up-to-date config values


=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#
# These rules should work for any debian-ish distro that uses systemd
# as init.  That does _not_ include Ubuntu 14.04 ("trusty"); look for
# its own special rule file.
#
# Please keep the diff between that and this relatively small, even if
# it means having suboptimal code; these need to be kept in sync by
# sentient bags of meat.

#export DH_VERBOSE=1
export DH_OPTIONS
export DH_GOPKG := github.com/snapcore/snapd
#export DEB_BUILD_OPTIONS=nocheck
export DH_GOLANG_EXCLUDES=tests
# skip Go generate, all source code should have been committed
export DH_GOLANG_GO_GENERATE=0

export PATH:=${PATH}:${CURDIR}
# GOCACHE is needed by go-1.13+
export GOCACHE:=/tmp/go-build

include /etc/os-release

# On 18.04 the released version of apt (1.6.1) has a bug that causes
# problem on "apt purge snapd". To ensure this won't happen add the
# right dependency on 18.04.
ifeq (${VERSION_ID},"18.04")
	SUBSTVARS = -Vsnapd:Breaks="apt (<< 1.6.3)"
endif
# Same as above for 18.10 just a different version.
ifeq (${VERSION_ID},"18.10")
	SUBSTVARS = -Vsnapd:Breaks="apt (<< 1.7.0~alpha2)"
endif

# this is overridden in the ubuntu/14.04 release branch
SYSTEMD_UNITS_DESTDIR="$(shell pkg-config --variable=systemdsystemunitdir systemd)"

# The go tool does not fully support vendoring with gccgo, but we can
# work around that by constructing the appropriate -I flag by hand.
GCCGO := $(shell go tool dist env > /dev/null 2>&1 && echo no || echo yes)

# Disable -buildmode=pie mode on i386 as can panics in spectacular
# ways (LP: #1711052).
# See also https://forum.snapcraft.io/t/artful-i386-panics/
# Note while the panic is only on artful, that's because artful
# detects it; the issue potentially there on older things.
BUILDFLAGS:=-pkgdir=$(CURDIR)/_build/std
ifneq ($(shell dpkg-architecture -qDEB_HOST_ARCH),i386)
BUILDFLAGS+= -buildmode=pie
endif

GCCGOFLAGS=
ifeq ($(GCCGO),yes)
GOARCH := $(shell go env GOARCH)
GOOS := $(shell go env GOOS)
BUILDFLAGS:=
GCCGOFLAGS=-gccgoflags="-I $(CURDIR)/_build/pkg/gccgo_$(GOOS)_$(GOARCH)/$(DH_GOPKG)/vendor"
export DH_GOLANG_GO_GENERATE=0
# workaround for https://github.com/golang/go/issues/23721
export GOMAXPROCS=2
endif

# check if we need to include the testkeys in the binary
# TAGS are the go build tags for all binaries, SNAP_TAGS are for snap
# build only.
TAGS=nosecboot
SNAP_TAGS=nosecboot nomanagers
ifneq (,$(filter testkeys,$(DEB_BUILD_OPTIONS)))
	TAGS+= withtestkeys
	SNAP_TAGS+= withtestkeys
endif

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

BUILT_USING_PACKAGES=
# export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# DPKG_EXPORT_BUILDFLAGS = 1
# include /usr/share/dpkg/buildflags.mk

# Currently, we enable confinement for Ubuntu only, not for derivatives,
# because derivatives may have different kernels that don't support all the
# required confinement features and we don't to mislead anyone about the
# security of the system.  Discuss a proper approach to this for downstreams
# if and when they approach us.
ifeq ($(shell dpkg-vendor --query Vendor),Ubuntu)
    # On Ubuntu 16.04 we need to produce a build that can be used on wide
    # variety of systems. As such we prefer static linking over dynamic linking
    # for stability, predicability and easy of deployment. We need to link some
    # things dynamically though: udev has no stable IPC protocol between
    # libudev and udevd so we need to link with it dynamically.
    VENDOR_ARGS=--enable-nvidia-multiarch --enable-static-libcap --enable-static-libapparmor --enable-static-libseccomp --with-host-arch-triplet=$(DEB_HOST_MULTIARCH)
ifeq ($(shell dpkg-architecture -qDEB_HOST_ARCH),amd64)
		VENDOR_ARGS+= --with-host-arch-32bit-triplet=$(shell dpkg-architecture -f -ai386 -qDEB_HOST_MULTIARCH)
endif
    BUILT_USING_PACKAGES=libcap-dev libapparmor-dev libseccomp-dev
else
ifeq ($(shell dpkg-vendor --query Vendor),Debian)
    VENDOR_ARGS=--enable-nvidia-multiarch
    BUILT_USING_PACKAGES=libcap-dev
else
    VENDOR_ARGS=--disable-apparmor
endif
endif
BUILT_USING=$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W $(BUILT_USING_PACKAGES))

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=_build

override_dh_fixperms:
	dh_fixperms -Xusr/lib/snapd/snap-confine


# The .real profile is a workaround for a bug in dpkg LP: #1673247 that causes
# ubiquity to crash. It allows us to "move" the snap-confine profile from
# snap-confine into snapd in a way that works with old dpkg that is in the live
# CD image.
#
# Because both the usual and the .real profile describe the same binary the
# .real profile takes priority (as it is loaded later).
override_dh_installdeb:
	dh_apparmor --profile-name=usr.lib.snapd.snap-confine.real -psnapd
	dh_installdeb

override_dh_clean:
	dh_clean
	$(MAKE) -C data clean
	# XXX: hacky
	$(MAKE) -C cmd distclean || true

override_dh_auto_build:
	# usually done via `go generate` but that is not supported on powerpc
	GO_GENERATE_BUILDDIR=_build/src/$(DH_GOPKG) GO111MODULE=off GOPATH=$$(pwd)/_build ./mkversion.sh
	# Build golang bits
	mkdir -p _build/src/$(DH_GOPKG)/cmd/snap/test-data
	cp -a cmd/snap/test-data/*.gpg _build/src/$(DH_GOPKG)/cmd/snap/test-data/
	cp -a bootloader/assets/data _build/src/$(DH_GOPKG)/bootloader/assets

	# exclude certain parts that won't be used by debian
	find _build/src/$(DH_GOPKG)/cmd/snap-bootstrap -name "*.go" | xargs rm -f
	find _build/src/$(DH_GOPKG)/cmd/snap-fde-keymgr -name "*.go" | xargs rm -f
	find _build/src/$(DH_GOPKG)/gadget/install -name "*.go" | grep -vE '(params\.go|install_dummy\.go|kernel\.go)'| xargs rm -f
	# XXX: once dh-golang understands go build tags this would not be needed
	find _build/src/$(DH_GOPKG)/secboot/ -name "*.go" | grep -E '(.*_sb(_test)?\.go|.*_tpm(_test)?\.go|secboot_hooks.go|keymgr/)' | xargs rm -f
	find _build/src/$(DH_GOPKG)/boot/ -name "*.go" | grep -E '(.*_sb(_test)?\.go)' | xargs rm -f
	# and build, we cannot use modules as packaging on Debian requires us to use
	# dependencies from the distro, and this would require further updates to the
	# go.mod file
	GO111MODULE=off dh_auto_build -- $(BUILDFLAGS) -tags "$(TAGS)" $(GCCGOFLAGS)

	(cd _build/bin && GO111MODULE=off GOPATH=$$(pwd)/.. go build $(BUILDFLAGS) $(GCCGOFLAGS) -tags "$(SNAP_TAGS)" $(DH_GOPKG)/cmd/snap)

	# (static linking on powerpc with cgo is broken)
ifneq ($(shell dpkg-architecture -qDEB_HOST_ARCH),powerpc)
	# Generate static snap-exec, snapctl and snap-update-ns - it somehow includes CGO so
	# we must force a static build here. We need a static snap-{exec,update-ns}
	# inside the core snap because not all bases will have a libc
	(cd _build/bin && GO111MODULE=off GOPATH=$$(pwd)/.. CGO_ENABLED=0 go build -tags "$(TAGS)" $(GCCGOFLAGS) -pkgdir=$$(pwd)/std $(DH_GOPKG)/cmd/snap-exec)
	(cd _build/bin && GO111MODULE=off GOPATH=$$(pwd)/.. CGO_ENABLED=0 go build -tags "$(TAGS)" $(GCCGOFLAGS) -pkgdir=$$(pwd)/std $(DH_GOPKG)/cmd/snapctl)
	(cd _build/bin && GO111MODULE=off GOPATH=$$(pwd)/.. go build -tags "$(TAGS)" --ldflags '-extldflags "-static"' $(GCCGOFLAGS) -pkgdir=$$(pwd)/std $(DH_GOPKG)/cmd/snap-update-ns)

	# ensure we generated a static build
	$(shell	if ldd _build/bin/snap-exec; then false "need static build"; fi)
	$(shell	if ldd _build/bin/snap-update-ns; then false "need static build"; fi)
	$(shell	if ldd _build/bin/snapctl; then false "need static build"; fi)
endif

	# ensure snap-seccomp is build with a static libseccomp on Ubuntu
ifeq ($(shell dpkg-vendor --query Vendor),Ubuntu)
	# (static linking on powerpc with cgo is broken)
 ifneq ($(shell dpkg-architecture -qDEB_HOST_ARCH),powerpc)
	sed -i "s|#cgo LDFLAGS:|#cgo LDFLAGS: /usr/lib/$(shell dpkg-architecture -qDEB_TARGET_MULTIARCH)/libseccomp.a|" _build/src/$(DH_GOPKG)/cmd/snap-seccomp/main.go
	(cd _build/bin && GOPATH=$$(pwd)/.. CGO_LDFLAGS_ALLOW="/.*/libseccomp.a" go build -tags "$(TAGS)" $(GCCGOFLAGS) $(DH_GOPKG)/cmd/snap-seccomp)
	# ensure that libseccomp is not dynamically linked

=== debian/tests/control ===
Tests: integrationtests
Restrictions: allow-stderr, rw-build-tree, needs-root, breaks-testbed, isolation-machine, needs-sudo, needs-internet
Depends: bzr,
         ca-certificates,
         git,
         golang-go,
         golang-golang-x-net-dev,
         locales,
         net-tools,
         netcat-openbsd,
         openssh-server,
         snapd,
         @builddeps@

## snapd 2.65.3

=== debian/changelog ===
snapd (2.65.3-1) unstable; urgency=medium

  [ Ernest Lotter ]
  * New upstream release, LP: #2077473
    - Fix missing aux info from store on snap setup

 -- Zygmunt Krynicki <me@zygoon.pl>  Thu, 19 Sep 2024 14:43:40 +0200

snapd (2.65.2-1) unstable; urgency=medium

  * New upstream release, LP: #2077473
    - Bump squashfuse from version 0.5.0 to 0.5.2 (used in snapd deb
      only)

 -- Ernest Lotter <ernest.lotter@canonical.com>  Fri, 06 Sep 2024 17:08:45 +0200

## snapd 2.66.1

=== debian/changelog ===
snapd (2.66.1-2) unstable; urgency=medium

  [ Zygmunt Krynicki ]
  * Add salsa CI/CD pipeline
  * Set LC_ALL=C.utf-8 for tests
  * Erase special mode of /var/lib/snapd/void
  * Adjust integration test to new upstream test suite behavior
  * Wrap and sort control files

  [ Bastian Germann ]
  * Remove Steve Langasek from Uploaders

 -- Zygmunt Krynicki <me@zygoon.pl>  Sat, 18 Jan 2025 08:42:06 +0000

snapd (2.66.1-1) unstable; urgency=medium

  [ Ernest Lotter ]
  * New upstream release, LP: #2083490
    - AppArmor prompting (experimental): Fix kernel prompting support
      check
    - Allow kernel snaps to have content slots
    - Fix ignoring snaps in try mode when amending

  [ Zygmunt Krynicki ]
  * Reabase all patches and drop patches applied upstream.

 -- Zygmunt Krynicki <me@zygoon.pl>  Thu, 28 Nov 2024 10:52:28 +0100

snapd (2.66-1) unstable; urgency=medium

  * New upstream release, LP: #2083490
    - AppArmor prompting (experimental): expand kernel support checks
    - AppArmor prompting (experimental): consolidate error messages and
      add error kinds
    - AppArmor prompting (experimental): grant /v2/snaps/{name} via
      snap-interfaces-requests-control
    - AppArmor prompting (experimental): add checks for duplicate
      pattern variants
    - Registry views (experimental): add handlers that commit (and
      cleanup) registry transactions
    - Registry views (experimental): add a snapctl fail command for
      rejecting registry transactions
    - Registry views (experimental): allow custodian snaps to implement
      registry hooks that modify and save registry data
    - Registry views (experimental): run view-changed hooks only for
      snaps plugging views affected by modified paths
    - Registry views (experimental): make registry transactions
      serialisable
    - Snap components: handle refreshing components to revisions that
      have been on the system before
    - Snap components: enable creating Ubuntu Core images that contain
      components
    - Snap components: handle refreshing components independently of
      snaps
    - Snap components: handle removing components when refreshing a snap
      that no longer defines them
    - Snap components: extend snapd Ubuntu Core installation API to
      allow for picking optional snaps and components to install
    - Snap components: extend kernel.yaml with "dynamic-modules",
      allowing kernel to define a location for kmods from component
      hooks
    - Snap components: renamed component type "test" to "standard"
    - Desktop IDs: support installing desktop files with custom names
      based on desktop-file-ids desktop interface plug attr
    - Auto-install snapd on classic systems as prerequisite for any non-
      essential snap install
    - Support loading AppArmor profiles on WSL2 with non-default kernel
      and securityfs mounted
    - Debian/Fedora packaging updates
    - Add snap debug command for investigating execution aspects of the
      snap toolchain
    - Improve snap pack error for easier parsing
    - Add support for user services when refreshing snaps
    - Add snap remove --terminate flag for terminating running snap
      processes
    - Support building FIPS complaint snapd deb and snap
    - Fix to not use nss when looking up for users/groups from snapd
      snap
    - Fix ordering in which layout changes are saved
    - Patch snapd snap dynamic linker to ignore LD_LIBRARY_PATH and
      related variables
    - Fix libexec dir for openSUSE Slowroll
    - Fix handling of the shared snap directory for parallel installs
    - Allow writing to /run/systemd/journal/dev-log by default
    - Avoid state lock during snap removal to avoid delaying other snapd
      operations
    - Add nomad-support interface to enable running Hashicorp Nomad
    - Add intel-qat interface
    - u2f-devices interface: add u2f trustkey t120 product id and fx
      series fido u2f devices
    - desktop interface: improve integration with xdg-desktop-portal
    - desktop interface: add desktop-file-ids plug attr to desktop
      interface
    - unity7 interface: support desktop-file-ids in desktop files rule
      generation
    - desktop-legacy interface: support desktop-file-ids in desktop
      files rule generation
    - desktop-legacy interface: grant access to gcin socket location
    - login-session-observe interface: allow introspection
    - custom-device interface: allow to explicitly identify matching
      device in udev tagging block
    - system-packages-doc interface: allow reading /usr/share/javascript
    - modem-manager interface: add new format of WWAN ports
    - pcscd interface: allow pcscd to read opensc.conf
    - cpu-control interface: add IRQ affinity control to cpu_control
    - opengl interface: add support for cuda workloads on Tegra iGPU in
      opengl interface

 -- Ernest Lotter <ernest.lotter@canonical.com>  Fri, 04 Oct 2024 14:22:03 +0200

## snapd 2.66.1+25.04

=== cmd/snap-update-ns/testdata/Makefile ===
# This makefiles uses grouped-target feature and relies on it for correctness.
ifeq (,$(findstring grouped-target,$(.FEATURES)))
$(error You need make with the grouped-taget feature to build this dataset)
endif

fstab_files = content-layout-1-initially-connected.current.fstab \
			  content-layout-1-initially-connected.desired.fstab \
			  content-layout-2-after-disconnect.desired.fstab \
			  content-layout-2-after-disconnect.current.fstab \
			  content-layout-3-after-reconnect.desired.fstab \
			  content-layout-3-after-reconnect.current.fstab \
			  content-layout-4-initially-disconnected-then-connected.before.current.fstab \
			  content-layout-4-initially-disconnected-then-connected.desired.fstab \
			  content-layout-4-initially-disconnected-then-connected.current.fstab \
			  content-layout-5-initially-connected-then-content-refreshed.before.current.fstab \
			  content-layout-5-initially-connected-then-content-refreshed.desired.fstab \
			  content-layout-5-initially-connected-then-content-refreshed.current.fstab \
			  content-layout-6-initially-connected-then-app-refreshed.before.current.fstab \
			  content-layout-6-initially-connected-then-app-refreshed.desired.fstab \
			  content-layout-6-initially-connected-then-app-refreshed.current.fstab

# None of the fstab files can be built in parallel as the depend on global system state.
.NOTPARALLEL: $(fstab_files)
.PHONY: all
all: $(fstab_files)

content-layout-1-initially-connected.desired.fstab content-layout-1-initially-connected.current.fstab &: test-snapd-content-layout_a_all.snap test-snapd-content_a_all.snap
	sudo snap remove --purge test-snapd-content-layout
	sudo snap remove --purge test-snapd-content
	sudo snap install --dangerous $(word 1,$^)
	sudo snap install --dangerous $(word 1,$^) # Reinstall to get another revision for better clarity of the data.
	sudo snap install --dangerous $(word 2,$^)
	sudo snap connect test-snapd-content-layout:just-content test-snapd-content:just-content
	snap run test-snapd-content-layout.sh -c true
	cp /var/lib/snapd/mount/snap.test-snapd-content-layout.fstab content-layout-1-initially-connected.desired.fstab
	cp /run/snapd/ns/snap.test-snapd-content-layout.fstab content-layout-1-initially-connected.current.fstab
	sudo snap remove --purge test-snapd-content-layout
	sudo snap remove --purge test-snapd-content
	patch <annotations-1.patch

content-layout-2-after-disconnect.desired.fstab content-layout-2-after-disconnect.current.fstab &: test-snapd-content-layout_a_all.snap test-snapd-content_a_all.snap
	sudo snap remove --purge test-snapd-content-layout
	sudo snap remove --purge test-snapd-content
	sudo snap install --dangerous $(word 1,$^)
	sudo snap install --dangerous $(word 1,$^) # Reinstall to get another revision for better clarity of the data.
	sudo snap install --dangerous $(word 2,$^)
	sudo snap connect test-snapd-content-layout:just-content test-snapd-content:just-content
	snap run test-snapd-content-layout.sh -c true
	sudo snap disconnect test-snapd-content-layout:just-content test-snapd-content:just-content
	cp /var/lib/snapd/mount/snap.test-snapd-content-layout.fstab content-layout-2-after-disconnect.desired.fstab
	cp /run/snapd/ns/snap.test-snapd-content-layout.fstab content-layout-2-after-disconnect.current.fstab
	sudo snap remove --purge test-snapd-content-layout
	sudo snap remove --purge test-snapd-content
	patch <annotations-2.patch

content-layout-3-after-reconnect.desired.fstab content-layout-3-after-reconnect.current.fstab &: test-snapd-content-layout_a_all.snap test-snapd-content_a_all.snap
	sudo snap remove --purge test-snapd-content-layout
	sudo snap remove --purge test-snapd-content
	sudo snap install --dangerous $(word 1,$^)
	sudo snap install --dangerous $(word 1,$^) # Reinstall to get another revision for better clarity of the data.
	sudo snap install --dangerous $(word 2,$^)
	sudo snap connect test-snapd-content-layout:just-content test-snapd-content:just-content
	snap run test-snapd-content-layout.sh -c true
	sudo snap disconnect test-snapd-content-layout:just-content test-snapd-content:just-content
	sudo snap connect test-snapd-content-layout:just-content test-snapd-content:just-content
	cp /var/lib/snapd/mount/snap.test-snapd-content-layout.fstab content-layout-3-after-reconnect.desired.fstab
	cp /run/snapd/ns/snap.test-snapd-content-layout.fstab content-layout-3-after-reconnect.current.fstab
	sudo snap remove --purge test-snapd-content-layout
	sudo snap remove --purge test-snapd-content
	patch <annotations-3.patch

content-layout-4-initially-disconnected-then-connected.before.current.fstab content-layout-4-initially-disconnected-then-connected.desired.fstab content-layout-4-initially-disconnected-then-connected.current.fstab &: test-snapd-content-layout_a_all.snap test-snapd-content_a_all.snap
	sudo snap remove --purge test-snapd-content-layout
	sudo snap remove --purge test-snapd-content
	sudo snap install --dangerous $(word 1,$^)
	sudo snap install --dangerous $(word 1,$^) # Reinstall to get another revision for better clarity of the data.
	sudo snap install --dangerous $(word 2,$^)
	snap connections test-snapd-content-layout | grep -xF 'content    test-snapd-content-layout:just-content  -     -'
	snap run test-snapd-content-layout.sh -c true
	# This file is used by unit tests model the changes needed after the refresh below.
	cp /run/snapd/ns/snap.test-snapd-content-layout.fstab content-layout-4-initially-disconnected-then-connected.before.current.fstab
	sudo snap connect test-snapd-content-layout:just-content test-snapd-content:just-content
	cp /var/lib/snapd/mount/snap.test-snapd-content-layout.fstab content-layout-4-initially-disconnected-then-connected.desired.fstab
	cp /run/snapd/ns/snap.test-snapd-content-layout.fstab content-layout-4-initially-disconnected-then-connected.current.fstab
	sudo snap remove --purge test-snapd-content-layout
	sudo snap remove --purge test-snapd-content
	patch <annotations-4.patch

content-layout-5-initially-connected-then-content-refreshed.before.current.fstab content-layout-5-initially-connected-then-content-refreshed.desired.fstab content-layout-5-initially-connected-then-content-refreshed.current.fstab &: test-snapd-content-layout_a_all.snap test-snapd-content_a_all.snap
	sudo snap remove --purge test-snapd-content-layout
	sudo snap remove --purge test-snapd-content
	sudo snap install --dangerous $(word 1,$^)
	sudo snap install --dangerous $(word 1,$^) # Reinstall to get another revision for better clarity of the data.
	sudo snap install --dangerous $(word 2,$^)
	sudo snap connect test-snapd-content-layout:just-content test-snapd-content:just-content
	snap run test-snapd-content-layout.sh -c true
	# This file is used by unit tests model the changes needed after the refresh below.
	cp /run/snapd/ns/snap.test-snapd-content-layout.fstab content-layout-5-initially-connected-then-content-refreshed.before.current.fstab
	sudo snap install --dangerous $(word 2,$^) # Refresh the content.
	cp /var/lib/snapd/mount/snap.test-snapd-content-layout.fstab content-layout-5-initially-connected-then-content-refreshed.desired.fstab
	cp /run/snapd/ns/snap.test-snapd-content-layout.fstab content-layout-5-initially-connected-then-content-refreshed.current.fstab
	sudo snap remove --purge test-snapd-content-layout
	sudo snap remove --purge test-snapd-content
	patch <annotations-5.patch

content-layout-6-initially-connected-then-app-refreshed.before.current.fstab content-layout-6-initially-connected-then-app-refreshed.desired.fstab content-layout-6-initially-connected-then-app-refreshed.current.fstab &: test-snapd-content-layout_a_all.snap test-snapd-content_a_all.snap
	sudo snap remove --purge test-snapd-content-layout
	sudo snap remove --purge test-snapd-content
	sudo snap install --dangerous $(word 1,$^)
	sudo snap install --dangerous $(word 1,$^) # Reinstall to get another revision for better clarity of the data.
	sudo snap install --dangerous $(word 2,$^)
	sudo snap connect test-snapd-content-layout:just-content test-snapd-content:just-content
	snap run test-snapd-content-layout.sh -c true
	# This file is used by unit tests model the changes needed after the refresh below.
	cp /run/snapd/ns/snap.test-snapd-content-layout.fstab content-layout-6-initially-connected-then-app-refreshed.before.current.fstab
	sudo snap install --dangerous $(word 1,$^) # Refresh the app.
	cp /var/lib/snapd/mount/snap.test-snapd-content-layout.fstab content-layout-6-initially-connected-then-app-refreshed.desired.fstab
	cp /run/snapd/ns/snap.test-snapd-content-layout.fstab content-layout-6-initially-connected-then-app-refreshed.current.fstab
	sudo snap remove --purge test-snapd-content-layout
	sudo snap remove --purge test-snapd-content
	patch <annotations-6.patch

test-snapd-content-layout_a_all.snap: test-snapd-content-layout
	snap pack $<

test-snapd-content_a_all.snap: test-snapd-content
	snap pack $<

## snapd 2.67

=== debian/changelog ===
snapd (2.67-1) unstable; urgency=medium

  [ Ernest Lotter ]
  * New upstream release, LP: #2089691
    - AppArmor prompting (experimental): allow overlapping rules
    - Registry view (experimental): Changes to registry data (from both
      users and snaps) can be validated and saved by custodian snaps
    - Registry view (experimental): Support 'snapctl get --pristine' to
      read the registry data excluding staged transaction changes
    - Registry view (experimental): Put registry commands behind
      experimental feature flag
    - Components: Make modules shipped/created by kernel-modules
      components available right after reboot
    - Components: Add tab completion for local component files
    - Components: Allow installing snaps and components from local files
      jointly on the CLI
    - Components: Allow 'snapctl model' command for gadget and kernel
      snaps
    - Components: Add 'snap components' command
    - Components: Bug fixes
    - eMMC gadget updates (WIP): add syntax support in gadget.yaml for
      eMMC schema
    - Support for ephemeral recovery mode on hybrid systems
    - Support for dm-verity options in snap-bootstrap
    - Support for overlayfs options and allow empty what argument for
      tmpfs
    - Enable ubuntu-image to determine the size of the disk image to
      create
    - Expose 'snap debug' commands 'validate-seed' and 'seeding'
    - Add debug API option to use dedicated snap socket /run/snapd-
      snap.socket
    - Hide experimental features that are no longer required
      (accepted/rejected)
    - Mount ubuntu-save partition with no{exec,dev,suid} at install, run
      and factory-reset
    - Improve memory controller support with cgroup v2
    - Support ssh socket activation configurations (used by ubuntu
      22.10+)
    - Fix generation of AppArmor profile with incorrect revision during
      multi snap refresh
    - Fix refresh app awareness related deadlock edge case
    - Fix not caching delta updated snap download
    - Fix passing non root uid, guid to initial tmpfs mount
    - Fix ignoring snaps in try mode when amending
    - Fix reloading of service activation units to avoid systemd errors
    - Fix snapd snap FIPS build on Launchpad to use Advantage Pro FIPS
      updates PPA
    - Make killing of snap apps best effort to avoid possibility of
      malicious failure loop
    - Alleviate impact of auto-refresh failure loop with progressive
      delay
    - Dropped timedatex in selinux-policy to avoid runtime issue
    - Fix missing syscalls in seccomp profile
    - Modify AppArmor template to allow using SNAP_REEXEC on arch
      systems
    - Modify AppArmor template to allow using vim.tiny (available in
      base snaps)
    - Modify AppArmor template to add read-access to debian_version
    - Modify AppArmor template to allow owner to read
      @{PROC}/@{pid}/sessionid
    - {common,personal,system}-files interface: prohibit trailing @ in
      filepaths
    - {desktop,shutdown,system-observe,upower-observe} interface:
      improve for Ubuntu Core Desktop
    - custom-device interface: allow @ in custom-device filepaths
    - desktop interface: improve launch entry and systray integration
      with session
    - desktop-legacy interface: allow DBus access to
      com.canonical.dbusmenu
    - fwupd interface: allow access to nvmem for thunderbolt plugin
    - mpris interface: add plasmashell as label
    - mount-control interface: add support for nfs mounts
    - network-{control,manager} interface: add missing dbus link rules
    - network-manager-observe interface: add getDevices methods
    - opengl interface: add Kernel Fusion Driver access to opengl
    - screen-inhibit-control interface: improve screen inhibit control
      for use on core
    - udisks2 interface: allow ping of the UDisks2 service
    - u2f-devices interface: add Nitrokey Passkey

 -- Zygmunt Krynicki <me@zygoon.pl>  Tue, 28 Jan 2025 06:59:45 +0000

snapd (2.45.3.1-1) unstable; urgency=m

=== debian/control ===
Source: snapd
Section: devel
Priority: optional
Maintainer: Michael Hudson-Doyle <mwhudson@debian.org>
Uploaders: Zygmunt Krynicki <me@zygoon.pl>,
           Luke Faraone <lfaraone@debian.org>,
           Michael Vogt <mvo@debian.org>
Build-Depends: debhelper (>= 13),
               dh-apparmor,
               dh-golang (>=1.7),
               autoconf,
               autoconf-archive,
               automake,
               bash-completion,
               ca-certificates,
               dbus,
               fakeroot,
               gcc-multilib [amd64],
               gettext,
               gnupg2,
               golang-dbus-dev,
               golang-github-bmatcuk-doublestar-dev,
               golang-github-coreos-bbolt-dev,
               golang-github-coreos-go-systemd-dev,
               golang-github-gorilla-mux-dev,
               golang-github-jessevdk-go-flags-dev,
               golang-github-juju-ratelimit-dev,
               golang-github-kr-pretty-dev,
               golang-github-mvo5-goconfigparser-dev,
               golang-github-seccomp-libseccomp-golang-dev,
               golang-go (>=2:1.18),
               golang-golang-x-crypto-dev,
               golang-golang-x-xerrors-dev,
               golang-gopkg-check.v1-dev,
               golang-gopkg-macaroon.v1-dev,
               golang-gopkg-mgo.v2-dev,
               golang-gopkg-retry.v1-dev,
               golang-gopkg-tomb.v2-dev (>= 0.0~git20161208.0.d5d1b58),
               golang-gopkg-tylerb-graceful.v1-dev,
               golang-gopkg-yaml.v2-dev,
               golang-gopkg-yaml.v3-dev,
               grub-common,
               indent,
               libapparmor-dev,
               libcap-dev,
               libglib2.0-dev,
               liblzo2-dev,
               libseccomp-dev,
               libudev-dev,
               openssh-client,
               pkg-config,
               python3,
               python3-docutils,
               python3-markdown,
               squashfs-tools,
               systemd-dev,
               tzdata,
               udev,
               xfslibs-dev
Standards-Version: 4.6.0
Homepage: https://github.com/snapcore/snapd
Vcs-Browser: https://salsa.debian.org/debian/snapd
Vcs-Git: https://salsa.debian.org/debian/snapd.git
XS-Go-Import-Path: github.com/snapcore/snapd

Package: golang-github-snapcore-snapd-dev
Architecture: all
Breaks: golang-github-ubuntu-core-snappy-dev (<< 2.0.6),
        golang-snappy-dev (<< 1.7.3+20160303ubuntu4)
Replaces: golang-github-ubuntu-core-snappy-dev (<< 2.0.6),
          golang-snappy-dev (<< 1.7.3+20160303ubuntu4)
Depends: ${misc:Depends}
Description: snappy development go packages.
 Use these to use the snappy API.

Package: snapd
Architecture: any
Depends: adduser,
         apparmor (>= 2.10.95-5),
         ca-certificates,
         default-dbus-session-bus | dbus-session-bus,
         gnupg1 | gnupg,
         kmod,
         openssh-client,
         squashfs-tools,
         systemd,
         udev,
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: snap-confine (<< 2.23),
          snapd-xdg-open (<= 0.0.0),
          ubuntu-core-launcher (<< 2.22),
          ubuntu-snappy (<< 1.9),
          ubuntu-snappy-cli (<< 1.9)
Breaks: snap-confine (<< 2.23),
        snapd-xdg-open (<= 0.0.0),
        ubuntu-core-launcher (<< 2.22),
        ubuntu-snappy (<< 1.9),
        ubuntu-snappy-cli (<< 1.9),
        ${snapd:Breaks}
Recommends: gnupg
Suggests: zenity | kdialog
Conflicts: snap (<< 2013-11-29-1ubuntu1)
Built-Using: ${Built-Using} ${misc:Built-Using}
Description: Daemon and tooling that enable snap packages
 Install, configure, refresh and remove snap packages. Snaps are
 'universal' packages that work across many different Linux systems,
 enabling secure distribution of the latest apps and utilities for
 cloud, servers, desktops and the internet of things.
 .
 Start with 'snap list' to see installed snaps.

Package: snap-confine
Architecture: any
Section: oldlibs
Depends: snapd (= ${binary:Version}), ${misc:Depends}
Description: Transitional package for snapd
 This is a transitional dummy package. It can safely be removed.

Package: ubuntu-core-launcher
Architecture: any
Depends: snapd (= ${binary:Version}), ${misc:Depends}
Section: oldlibs
Pre-Depends: dpkg (>= 1.15.7.2)
Description: Transitional package for snapd
 This is a transitional dummy package. It can safely be removed.

## snapd 2.67.1+22.04

=== data/systemd/Makefile ===
#
# Copyright (C) 2017 Canonical Ltd
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

SNAPD_ENVIRONMENT_FILE := /etc/environment
SNAP_MOUNT_DIR ?= /snap
BINDIR := /usr/bin
LIBEXECDIR := /usr/lib
SYSTEMDSYSTEMUNITDIR := /lib/systemd/system

# NOTE: the code in wrappers/core18.go assumes that all our service units's
# name start with the "snapd." prefix; units whose filename does not have this
# prefix will not be installed on the host!
SYSTEMD_UNITS_GENERATED := $(wildcard *.in)
# NOTE: sort removes duplicates so this gives us all the units, generated or otherwise
SYSTEMD_UNITS = $(sort $(SYSTEMD_UNITS_GENERATED:.in=) $(wildcard *.service) $(wildcard *.timer) $(wildcard *.socket) $(wildcard *.target))

.PHONY: all
all: $(SYSTEMD_UNITS) check

.PHONY: check
check: snapd.run-from-snap snapd.core-fixup.sh
	if command -v shellcheck >/dev/null; then shellcheck $^; fi

.PHONY: install
install: $(SYSTEMD_UNITS)
	# NOTE: old (e.g. 14.04) GNU coreutils doesn't -D with -t
	install -d -m 0755 $(DESTDIR)/$(SYSTEMDSYSTEMUNITDIR)
	install -m 0644 -t $(DESTDIR)/$(SYSTEMDSYSTEMUNITDIR) $^
	install -d -m 0755 $(DESTDIR)/$(LIBEXECDIR)/snapd
	install -m 0755 -t $(DESTDIR)/$(LIBEXECDIR)/snapd snapd.core-fixup.sh
	install -m 0755 -t $(DESTDIR)/$(LIBEXECDIR)/snapd snapd.run-from-snap

.PHONY: clean
clean:
	rm -f $(SYSTEMD_UNITS_GENERATED:.in=)

%: %.in
	cat $< | \
		sed s:@libexecdir@:$(LIBEXECDIR):g | \
		sed s:@SNAPD_ENVIRONMENT_FILE@:$(SNAPD_ENVIRONMENT_FILE):g | \
		sed s:@bindir@:$(BINDIR):g | \
		sed s:@SNAP_MOUNT_DIR@:$(SNAP_MOUNT_DIR):g  | \
		cat > $@

## snapd 2.67.1+25.04

=== data/Makefile ===
all install clean:
	$(MAKE) -C systemd $@
	$(MAKE) -C systemd-user $@
	$(MAKE) -C systemd-env $@
	$(MAKE) -C systemd-tmpfiles $@
	$(MAKE) -C dbus $@
	$(MAKE) -C env $@
	$(MAKE) -C desktop $@
	$(MAKE) -C polkit $@
